<?php
/**
 * папка MetaXLib_cfg - отвечает за непосредственное определение экземпляров
 *                 		библиотеки: перечислений, потоков (в будущем), комбобоксов,
 *                   	гридов
 * файл MetaXLib_cfg.php - непосредственная настройка:
 * 		1. путь конфигурации библиотеки
 * 		2. путь библиотечных фалов
 * 		3. url библиотечных файлов
 * 		4. загрузка файла конфигурации библиотеки
 * 		5. загрузка файла локализации библиотеки
 * 		6. определение нестандартных вещей, например БД или переключаение 
 * 		   режима работы сервера php  
 */
error_reporting(E_ALL);

/**
 * Настройка для проверки является ли путь абсолютным. Для windows ':\\', 
 * для unix надо брать первый раздел например: '/var/';
 */
if (!defined('MARK_TO_CHECK_ABSOLUTE_PATH'))
   define('MARK_TO_CHECK_ABSOLUTE_PATH', ':\\');
   
/**
 * Автозагрузка классов: Расширение для файлов классов, с которыми будет работать автозагрузчик.                       
 */
define('MXL_Autoload_ext',      'php');
/**
 * Автозагрузка классов: Перфикс который содержат имена классов 
 */
define('MXL_Autoload_pref',     'mxl_');
/**
 * Автозагрузка классов: Разделитель имен пакетов
 */
define('MXL_Autoload_bar',      '_');
/**
 * Автозагрузка классов: Разделитель каталогов
 */
define('MXL_Autoload_pathsep',  "\/");


mxl_cfg_base::setMetaXLibcfg_path(realpath(dirname(__FILE__)));
mxl_cfg_base::setMetaXLib_path(realpath(dirname(__FILE__).'src/'));
mxl_cfg_base::setMetaXLib_url('src/');

mxl_cfg_base::readCfgFromJSONFile('mxl_cfg.mxl');
mxl_cfg_base::readLocalizationFromJSONFile('russian');

if (!defined('IN_SYS'))
   define('IN_SYS', true);
?>