<?php
/**
 * Файл для описания класса системных сообщений об ошибках, 
 * {@link mxl_cfg_exceptions}.
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс описания системных сообщений об ошибках
 * 
 * @package mxl_cfg
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_cfg_exceptions{
	/**
	 * исключение выбрасывается если не удалось зарегистрировать
	 * автозагрузчик классов библиотеки
	 */
	public static $autoload_register;
	/**
	 * исключение выбрасывается если не удалось отменить регистрацию
	 * автозагрузчика классов библиотеки
	 */
	public static $autoload_unregister;
	/**
	 * исключение выбрасывается если не удалось найти файл для автозагрузки
	 * класса.
	 * #VTINS - макрос будет заменен на имя файла
	 * #VTINS1 - макрос будет заменен на имя класса
	 */
	public static $autoload_load;
	
	public static $json_depth;
	public static $json_ctrl_char;
	public static $json_syntax;
	
	/**
	 * Исключение выбрасывается перед добавлением значения перечисления,
	 * в случае если перечисление уже имеет значение с таким ключем
	 * #VTINS - макрос будет заменен на ключ перечисления
	 */
	public static $core_enum_addEnumField;
	
	/**
	 * исключение выбрасывается перед добавлением новой логической БД,
	 * в случае если уже есть логическая БД с таким именем
	 * #VTINS - макрос будет заменен на имя логической БД, для которой
	 * ведется процесс добавления
	 */
	public static $core_logicbases_checkDontHave;
	/**
	 * выбрасывается если не найден файл для загрузки cо сформированным
	 * именем
	 * #VTINS - макрос будет заменен на имя файла, которое не удалось найти
	 */
	public static $core_logicbases_loadLogicBase;
	/**
	 * выбрасывается если не найдена логическая БД с таким именем.
	 * #VTINS - макрос будет заменен на имя логической БД, которую не
	 * удалось найти
	 */
	public static $core_logicbases_getLogicBase;
	
	/**
	 * исключение выбрасывается в случае если не найден файл для 
	 * загрузки метаданного их json.
	 * #VTINS - макрос будет заменен на имя не найденого файла
	 */
	public static $core_metadata__json_file_not_find;
	
	/**
	 * исключение выбрасывается в случае если происходит операрация
	 * с неподдерживаемым типом метаданного.
	 * #VTINS - макрос будет заменен на тип метаданного для которого
	 * велась проверка
	 */
	public static $core_metadatas_checkType;
	
	/**
	 * исключение выбрасывается перед добавлением нового метаданного,
	 * в случае если уже есть метаданное с таким именем и типом
	 * #VTINS - макрос будет заменен на имя метаданного
	 * #VTINS1 - макрос будет заменен на тип метаданного
	 */
	public static $core_metadatas_checkDontHave;
	
	/**
	 * выбрасывается если не найдено метаданное с таким именем и типом.
	 * #VTINS - макрос будет заменен на имя метаданного
	 * #VTINS1 - макрос будет заменен на тип метаданного
	 */
	public static $core_metadatas_getMetaData;
	
	
	/**
	 * Исключение выбрасывается перед добавлением параметра,
	 * в случае если уже есть параметр с таким именем
	 * #VTINS - макрос будет заменен на имя параметра
	 */
	public static $core_params_addParam;
	
	/**
	 * Исключение выбрасывается в процедуре добавления параметров из
	 * ассоциированного массива, перед добавлением параметра,
	 * в случае если нарушена структура ассоциированного массива или
	 * не указано имя параметра
	 * #VTINS - макрос будет заменен имя и значение параметра
	 */
	public static $core_params_addParamsFromArray;
	
	/**
	 * Исключение выбрасывается если не удалось найти параметр с указанным
	 * именем
	 * #VTINS - макрос будет заменен имя параметра
	 */
	public static $core_params_getParamValue;
	
    
    
	/**
	 * выбрасывается если нет поля в результирующем наборе, а в словаре (mxl) оно прописано.
	 * #VTINS - макрос будет заменен на имя полей, которые не найдены в результирующем наборе
	 */
	public static $dict_dbgrid_getJson_haventFields;
	/**
	 * выбрасывается если идет обращение к функции получения строки итогов
	 * по гриду, а грид не находится в режиме итогов по гриду.
	 * #VTINS - макрос будет заменен на имя грида
	 */
	public static $dict_dbgrid_getTotalGridStr;
	/**
	 * выбрасывается если не удалось найти поле к которому было обращение.
	 * #VTINS - макрос будет заменен на имя поля
	 */
	public static $dict_dbgrid_getFieldByName;
	
	/**
	 * выбрасывается если возникли ошибки при загрузке из json. Данное сообщение
	 * дополняется сообщение об ошибке которая инициировала выброс этого исключения.
	 * #VTINS - макрос будет заменен на имя грида
	 * #VTINS1 - макрос будет заменен на имя json Файла
	 */
	public static $dict_dbgrid_loadFromJSON;
	
	/**
	 * выбрасывается если возникла ошибка при проверке наличия ключевого поля для 
	 * связи.
	 * #VTINS - макрос будет заменен на имя проверяемого поля
	 * #VTINS1 - макрос будет заменен на описатель связи
	 */
	public static $dict_dbgrid_checkRelation_keyField;
	
	/**
	 * выбрасывается когда тип данных поля не проходит проверку.
	 * #VTINS - макрос будет заменен на тип данных поля, для которого 
	 * производилась проверка
	 */
	public static $dict_dbgridfield_checkType;
	
	/**
	 * выбрасывается когда тип данных поля не проходит проверку.
	 * #VTINS - макрос будет заменен на тип данных поля, для которого 
	 * производилась проверка
	 */
	public static $dict_dbgridfield_checkType_fieldName;
	
	
	/**
	 * выбрасывается когда тип итога не проходит проверку.
	 * #VTINS - макрос будет заменен на тип итога, для которого производилась
	 * проверка
	 */
	public static $dict_dbgridtotalfooter_checkType;
	
	/**
	 * выбрасывается когда тип итога не проходит проверку.
	 * #VTINS - макрос будет заменен на тип итога, для которого производилась
	 * проверка
	 */
	public static $dict_dbgridtotalgrid_checkType;
	
	/**
	 * выбрасывается когда в атрибутах есть незарегистрированный атрибут
	 * #VTINS - макрос будет заменен на строку атрибутов
	 */
	public static $dict_fieldattribs_checkFieldAttribs;
	
	/**
	 * Выбрасывается в случае неудачной проверки правила валидации на 
	 * его поддержку системой.
	 * #VTINS - макрос будет заменен на имя секции
	 * #VTINS1 - макрос будет заменен на имя правила
	 */
	public static $dict_validator_checkRule;
	
	/**
	 * Выбрасывается когда длина логина выходит за допустимые границы
	 */
	public static $dict_validator_rulescommon_checkLogin1;
	
	/**
	 * Выбрасывается когда в логине используются недопустимые символы
	 */
	public static $dict_validator_rulescommon_checkLogin2;
	
	/**
	 * Выбрасывается когда логин начинается не с буквы или цифры
	 */
	public static $dict_validator_rulescommon_checkLogin3;
	
	/**
	 * Выбрасывается когда длина пароля выходит за допустимые границы
	 */
	public static $dict_validator_rulescommon_checkPassword1;
	
	/**
	 * Регулярное выражение для проверки пароля
	 */
	public static $dict_validator_rulescommon_checkPassword2;
	
	/**
	 * Выбрасывается когда в пароле используются недопустимые символы
	 */
	public static $dict_validator_rulescommon_checkPassword3;
	
	/**
	 * Выбрасывается когда значение не соответствует регулярному выражению
	 */
	public static $dict_validator_rulescommon_match;
	
	/**
	 * Выбрасывается в случае превышения допустимой длины 
	 * дробной части числа с плавающей точкой.
	 */
	public static $dict_validator_rulescommon_checkType1;
	
	/**
	 * Выбрасывается когда дата не соответствует заданному формату
	 */
	public static $dict_validator_rulescommon_checkType2;
	
	/**
	 * Выбрасывается в случае превышения допустимой длины 
	 * строки
	 */
	public static $dict_validator_rulescommon_checkType3;
	
	/**
	 * Выбрасывается когда длина логина выходит за допустимые границы
	 */
	public static $dict_validator_rulesdbgrid_checkLogin1;
	
	/**
	 * Выбрасывается когда в логине используются недопустимые символы
	 */
	public static $dict_validator_rulesdbgrid_checkLogin2;
	
	/**
	 * Выбрасывается когда логин начинается не с буквы или цифры
	 */
	public static $dict_validator_rulesdbgrid_checkLogin3;
	
	/**
	 * Выбрасывается когда длина пароля выходит за допустимые границы
	 */
	public static $dict_validator_rulesdbgrid_checkPassword1;
	
	/**
	 * Регулярное выражение для проверки пароля
	 */
	public static $dict_validator_rulesdbgrid_checkPassword2;
	
	/**
	 * Выбрасывается когда в пароле используются недопустимые символы
	 */
	public static $dict_validator_rulesdbgrid_checkPassword3;
	
	/**
	 * Выбрасывается когда значение не соответствует регулярному выражению
	 */
	public static $dict_validator_rulesdbgrid_match;
	
	/**
	 * Выбрасывается в случае превышения допустимой длины 
	 * дробной части числа с плавающей точкой.
	 */
	public static $dict_validator_rulesdbgrid_checkType1;
	
	/**
	 * Выбрасывается в случае превышения допустимой длины 
	 * строки
	 */
	public static $dict_validator_rulesdbgrid_checkType2;
		
	/**
	 * выдается если файл имеет формат отличный от указанного base->json_file_ext
	 * Вместо макроса #VTINS, будет вставлено значение формата
	 */
	public static $utils_json_read_from_file_not_lib_ext;
	
	/**
	 * Исключение для перехвата и дополнения исключения о об отсуствии параметра
	 * или снипетта.
	 * Дополняет исключение информацией по загружаемому json файлу
	 * #VTINS - макрос будет заменен на имя json файла в котором произошла ошибка 
	 */
	public static $utils_json_readJSONFromFile_havent;
	
	
	/**
	 * Исключение выбрасывается если не удалось найти файл сниппета.
	 * #VTINS - макрос будет заменен на имя файла сниппета 
	 */
	public static $utils_snippet_executeSnippet;
	
	/**
	 * исключение выбрасывается перед переопределением обработчика события,
	 * в случае если компонент не поддерживает обработку такого типа 
	 * обработчиков событий.  
	 * #VTINS - макрос будет заменен на тип обработчика, для которого
	 * ведется процесс добавления
	 */
	public static $widget_widget_setEventHandler;
	
	/**
	 * исключение выбрасывается перед добавлением нового виджета,
	 * в случае если уже есть виджет с таким именем
	 * #VTINS - макрос будет заменен на имя виджета, для которого
	 * ведется процесс добавления
	 */
	public static $widget_widgets_checkDontHave;
	/**
	 * исключение выбрасывается если проверяемый виджет не является
	 * объектом класса mxl_widget_datetime
	 */
	public static $widget_widgets_checkWidgetIsDateTime;
	
	/**
	 * функция читает массив параметров исключений и заполняет статичные 
	 * переменные класса mxl_cfg_exceptions, для их дальнейшего использования.
	 * @param $cfg
	 */
	public static function readJSON($cfg){
		mxl_cfg_exceptions::$autoload_register   = $cfg['exceptions']['autoload']['register'];
		mxl_cfg_exceptions::$autoload_unregister = $cfg['exceptions']['autoload']['unregister'];
		mxl_cfg_exceptions::$autoload_load       = $cfg['exceptions']['autoload']['load'];
		
		
		mxl_cfg_exceptions::$json_depth     = $cfg['exceptions']['json']['depth'];
		mxl_cfg_exceptions::$json_ctrl_char = $cfg['exceptions']['json']['ctrl_char'];
		mxl_cfg_exceptions::$json_syntax    = $cfg['exceptions']['json']['syntax'];
		
		mxl_cfg_exceptions::$core_enum_addEnumField   = $cfg['exceptions']['core']['enum']['addEnumField'];
		
		mxl_cfg_exceptions::$core_logicbases_checkDontHave = $cfg['exceptions']['core']['logicbases']['checkDontHave'];
		mxl_cfg_exceptions::$core_logicbases_loadLogicBase = $cfg['exceptions']['core']['logicbases']['loadLogicBase'];
		mxl_cfg_exceptions::$core_logicbases_getLogicBase  = $cfg['exceptions']['core']['logicbases']['getLogicBase'];
		
		mxl_cfg_exceptions::$core_metadata__json_file_not_find = $cfg['exceptions']['core']['metadata']['json_file_not_find'];
		
		mxl_cfg_exceptions::$core_metadatas_checkType     = $cfg['exceptions']['core']['metadatas']['checkType'];
		mxl_cfg_exceptions::$core_metadatas_checkDontHave = $cfg['exceptions']['core']['metadatas']['checkDontHave'];
		mxl_cfg_exceptions::$core_metadatas_getMetaData   = $cfg['exceptions']['core']['metadatas']['getMetaData'];
		
		
		mxl_cfg_exceptions::$core_params_addParam           = $cfg['exceptions']['core']['params']['addParam'];
		mxl_cfg_exceptions::$core_params_addParamsFromArray = $cfg['exceptions']['core']['params']['addParamsFromArray'];
		mxl_cfg_exceptions::$core_params_getParamValue      = $cfg['exceptions']['core']['params']['getParamValue'];
		
		mxl_cfg_exceptions::$dict_dbgrid_getJson_haventFields   = $cfg['exceptions']['dict']['dbgrid']['getJson_haventFields'];
		mxl_cfg_exceptions::$dict_dbgrid_getTotalGridStr        = $cfg['exceptions']['dict']['dbgrid']['getTotalGridStr'];
		mxl_cfg_exceptions::$dict_dbgrid_getFieldByName         = $cfg['exceptions']['dict']['dbgrid']['getFieldByName'];
		mxl_cfg_exceptions::$dict_dbgrid_loadFromJSON           = $cfg['exceptions']['dict']['dbgrid']['loadFromJSON'];
		mxl_cfg_exceptions::$dict_dbgrid_checkRelation_keyField = $cfg['exceptions']['dict']['dbgrid']['checkRelation_keyField'];
		
				
		mxl_cfg_exceptions::$dict_dbgridfield_checkType = $cfg['exceptions']['dict']['dbgridfield']['checkType'];
		mxl_cfg_exceptions::$dict_dbgridfield_checkType_fieldName = $cfg['exceptions']['dict']['dbgridfield']['checkType_fieldName'];
		
		mxl_cfg_exceptions::$dict_dbgridtotalfooter_checkType = $cfg['exceptions']['dict']['dbgridtotalfooter']['checkType'];
		mxl_cfg_exceptions::$dict_dbgridtotalgrid_checkType   = $cfg['exceptions']['dict']['dbgridtotalgrid']['checkType'];
		
		mxl_cfg_exceptions::$dict_fieldattribs_checkFieldAttribs = $cfg['exceptions']['dict']['fieldattribs']['checkFieldAttribs'];
		
		mxl_cfg_exceptions::$dict_validator_checkRule = $cfg['exceptions']['dict']['validator']['checkRule'];
		
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkLogin1    = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkLogin1'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkLogin2    = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkLogin2'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkLogin3    = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkLogin3'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkPassword1 = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkPassword1'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkPassword2 = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkPassword2'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkPassword3 = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkPassword3'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_match          = $cfg['exceptions']['dict']['validator_']['rulescommon']['match'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkType1     = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkType1'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkType2     = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkType2'];
		mxl_cfg_exceptions::$dict_validator_rulescommon_checkType3     = $cfg['exceptions']['dict']['validator_']['rulescommon']['checkType3'];
		
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkLogin1    = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkLogin1'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkLogin2    = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkLogin2'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkLogin3    = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkLogin3'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkPassword1 = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkPassword1'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkPassword2 = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkPassword2'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkPassword3 = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkPassword3'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_match          = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['match'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkType1     = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkType1'];
		mxl_cfg_exceptions::$dict_validator_rulesdbgrid_checkType2     = $cfg['exceptions']['dict']['validator_']['rulesdbgrid']['checkType2'];
		
		mxl_cfg_exceptions::$utils_json_read_from_file_not_lib_ext =
				$cfg['exceptions']['utils']['json']['read_from_file_not_lib_ext'];
		if (strpos(mxl_cfg_exceptions::$utils_json_read_from_file_not_lib_ext, 
				'#VTINS') !== false)
			mxl_cfg_exceptions::$utils_json_read_from_file_not_lib_ext = 
					str_replace('#VTINS', mxl_cfg_base::$json_file_ext, 
					mxl_cfg_exceptions::$utils_json_read_from_file_not_lib_ext);
					
		mxl_cfg_exceptions::$utils_json_readJSONFromFile_havent =
				$cfg['exceptions']['utils']['json']['readJSONFromFile_havent'];
					
		mxl_cfg_exceptions::$utils_snippet_executeSnippet = $cfg['exceptions']['utils']['snippet']['executeSnippet'];

		mxl_cfg_exceptions::$widget_widget_setEventHandler  = $cfg['exceptions']['widget']['widget']['setEventHandler'];
		
		mxl_cfg_exceptions::$widget_widgets_checkDontHave         = $cfg['exceptions']['widget']['widgets']['checkDontHave'];
		mxl_cfg_exceptions::$widget_widgets_checkWidgetIsDateTime = $cfg['exceptions']['widget']['widgets']['checkWidgetIsDateTime'];
		
	}
}
?>