<?php
/**
 * Файл для описания класса логической БД, {@link mxl_core_logicbase}.
 * @package mxl_core
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс описания хранилища логической БД.
 * Используется для хранения информации о логической БД и указателя на экземпляр
 * соединения с БД.
 * 
 * @package mxl_core
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_core_logicbase{
	private $caption;
	private $name;
	
	/**
	 * непосредственный объект подключения к бд.
	 * 
	 * @var unknown_type
	 */
	private $mxl_db;

	/**
	 * Конструктор класса. Создает объект и инициализирует свойства класса.
	 * @param $name
	 * @param $caption
	 * @param $mxl_db
	 * @return mxl_core_logicbase
	 */
	public function __construct($name, $caption, $mxl_db){
		$this->name    = $name;
		$this->caption = $caption;
		$this->mxl_db  = $mxl_db;
	}
	
	/**
	 * Дуструтор логической БД. Освобождает указатель на экземпляр подключения
	 * к БД.
	 */
	public function __destruct(){
		unset($this->listEnumFields);
	}
	
	/**
	 * Возвращает заголовок логической БД.
	 * @return string
	 */
	public function getCaption(){
		return $this->caption;
	}
	
	/**
	 * Возвращает указатель на объект подключения к БД.
	 * @return sql_db
	 */
	public function getMXL_DB(){
		return $this->mxl_db;
	}
}
?>