<?php
/**
 * Файл для описания класса работы с файлами, {@link mxl_utils_files}.
 * @package mxl_utils
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
/**
 * Класс для работы с файлами.
 * @package mxl_utils
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_utils_files{
	/**
	 * функция возвращает расширение файла
	 * @param $filename - полное имя файла.
	 * @return string
	 */
	public static function getExtension($filename) {
		//return substr($fileName, strrpos($fileName, '.') + 1);
		return end(explode(".", $filename));
	}
	
	/**
	 * функция проверяет является ли $filename - абсолютным путем 
	 * @param $filename - полное имя файла и ли директория для проверки
	 * @return boolean
	 */
	public static function isAbsolute($filename){
		return (strpos($filename, MARK_TO_CHECK_ABSOLUTE_PATH) !== false);
	}
	
	/**
	 * Функция проверяет авляется ли путь абсолютным, если нет то строит 
	 * абсолютный путь относительно размещения конфигурации библиотеки.
	 * @param $fileName
	 * @return string
	 */
	public static function makeAbsolute($fileName, $path = ''){
		if (!mxl_utils_files::isAbsolute($fileName)){
			if (!$path)
				$path = mxl_cfg_path::$metaxlib_cfg;	
			$fileName = $path.mxl_cfg_path::$separator.$fileName;
		}
		return $fileName;
	}
}
?>