<?php
/**
 * Файл для описания класса работы snnipet, {@link mxl_utils_snippet}.
 * @package mxl_utils
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2010, ООО НПО Метарекс
 */
/**
 * Класс для работы с динамическими блоками (функциями) в тексте файлов словарей
 * в формате json.
 * @package mxl_utils
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2010, ООО НПО Метарекс, {@link http://www.metarex.ru www.metarex.ru}
 */
class mxl_utils_snippet{
	/**
	 * Функция расчитывает имя файла сниппета, создает объект для получения
	 * результата работы снипета, вызывает функцию исполнения сниппета,
	 * возвращает полученный результат.
	 * @param $snippet - тело сниппета (пока только имя)
	 * @throws Exception {@link mxl_cfg_exceptions::$utils_snippet_executeSnippet}
	 * @return string
	 */
	public static function execute($snippet, $jsonFileDir, 
			mxl_core_params $params){
		$snippetName = $snippet;
		
		$fileName = $jsonFileDir.mxl_cfg_path::$separator
				.mxl_cfg_path::$snippet.mxl_cfg_path::$separator
				.$snippetName.'.'.mxl_cfg_base::$snippet_file_ext;
		
		if (!mxl_utils_snippet::isSnippetExist($fileName))
			return false;
				
		$jsSnip = new mxl_utils_snippet();
		
		$jsSnip->dParams = ((!$params->isEmpty())?$params->getListParams():array());
			
		$snipRes = $jsSnip->executeSnippetFile($fileName);
		
		unset($jsSnip);
		
		return ($snipRes);
	}
	
	/**
	 * Проверяет наличие файла сниппета, если отсутствует то выбрасывает исключение
	 * @param string $snippetFileName
	 * @throws {@link mxl_cfg_exceptions::$utils_snippet_executeSnippet}
	 * @return string
	 */
	public static function isSnippetExist($snippetFileName){
		if (!file_exists($snippetFileName)){
			$errMess = mxl_cfg_exceptions::$utils_snippet_executeSnippet;
			if (strpos($errMess, '#VTINS') !== false)
				$errMess = str_replace('#VTINS', $snippetFileName, $errMess);
			
			throw new Exception($errMess);
			return false;
		}		
		return true;
	}
	
	/**
	 * Переменная необходима для возвращения данных из сниппета.
	 * @var string
	 */
	public $result;
	
	/**
	 * Переменная для передачи динамических параметров в тело сниппета
	 * @var array
	 */
	public $dParams;
	
	/**
	 * Функция исполняет сниппет и возвращает результат
	 * @param string $snippetFileName - имя файла сниппета
	 * @return string
	 */
	protected function executeSnippetFile($snippetFileName){
		include $snippetFileName;
		
		return $this->result;
	}
	
}
?>