<?php
/**
 * Файл конролеер для комбобоксов - разбирает запрос сервера и в 
 * зависимости от вида запроса формирует ответ.
 * Обрабатываются запросы на получение данных от сервера для визуальной части.
 * 
 * В запросе обязательно должен присутствоавать параметр comboName - 
 * определяющий имя комбобокса для которого необходимо вернуть данные.
 * 
 * Возможно задание дополнительного параметра для ограничения выходного масива
 * данных по отображаемому полю: query_seach. Задание этого параметра приводит
 * к отбору данных содержащих текст query_seach.
 * 
 * В случае успешного запроса, ответ формируется функцией 
 * {@link mxl_dict_combobox::getJSON()}.
 * В случае неудачного запроса выводится {failure:true}.
 * 
 * @package mxl_widget
 * @author merlin <merlin@ersys.ru>
 * @copyright Copyright (c) 2009, ООО НПО Метарекс
 */
include_once realpath(dirname(__FILE__).'/../../init.php');

try{
	if (isset(mxl_cfg_url::$controller)){

		$postArr = array('q_controller_type'=>'combobox');
		foreach ($_POST as $pi => $pv)
			$postArr[$pi] = $pv;
		
		$opts = array('http' =>
    		array(
        		'method'  => 'POST',
        		'header'  => 'Content-type: application/x-www-form-urlencoded',
		        'content' => http_build_query($postArr)
    		)
		);

		$context  = stream_context_create($opts);

		$result = file_get_contents(mxl_cfg_url::$controller, false, $context);	
        echo $result;
	} else {
		
		$MDS = mxl_core_metadatas::instance();

		$comboName = '';
		if (isset($_POST['comboName']))
			$comboName = $_POST['comboName'];
	
		$params = '';
		if (isset($_POST['params'])) {
			$params = $_POST['params'];
	
			$paramsMXL = new mxl_core_params();
			$paramsMXL->loadFromJSON($params);

			$MDS->setCurrParams($paramsMXL);
		}

		$result = false;

		$cmbx = $MDS->getMetaData(mxl_core_metadatas::$combobox, $comboName);

		/**
 		* Для варианта seachCombo, передается запрос на поиск (текст из комбо),
 		* имя параметра 'query_seach'
 		*/
		if (isset($_POST['query_seach'])){
			$query_seach = $_POST['query_seach'];
			$cmbx->setQuerySeach($query_seach);
		}

		if ($cmbx->getJSON())
			$result = true;

		if (!$result)
    		echo '{failure:true}';
	}
    	
} catch (Exception $e){
	echo '{failure:true, error:'.json_encode(mxl_utils_exceptions::toHtml($e)).'}';
}
?>